// ArroyoDataLoggerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ArroyoDataLogger.h"
#include "ArroyoDataLoggerDlg.h"
#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
public:
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

// CArroyoDataLoggerDlg dialog

CArroyoDataLoggerDlg::CArroyoDataLoggerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CArroyoDataLoggerDlg::IDD, pParent)
	, m_strFilename(_T(""))
	, m_nInterval(1000)
	, m_strCommand(_T(""))
	, m_bLogging(false)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CArroyoDataLoggerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_FILENAME, m_strFilename);
	DDX_Text(pDX, IDC_INTERVAL, m_nInterval);
	DDV_MinMaxInt(pDX, m_nInterval, 100, 10000000);
	DDX_Control(pDX, IDC_BAUD, m_cbBaud);
	DDX_Text(pDX, IDC_COMMAND, m_strCommand);
	DDX_Control(pDX, IDC_PORT, m_cbPort);
}

BEGIN_MESSAGE_MAP(CArroyoDataLoggerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DEVICECHANGE()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CArroyoDataLoggerDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BROWSE, &CArroyoDataLoggerDlg::OnBnClickedBrowse)
	ON_BN_CLICKED(IDC_STOP, &CArroyoDataLoggerDlg::OnBnClickedStop)
	ON_BN_CLICKED(IDCANCEL, &CArroyoDataLoggerDlg::OnBnClickedCancel)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CArroyoDataLoggerDlg message handlers

BOOL CArroyoDataLoggerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	PopulateCOMPorts(m_cbPort, theApp.GetProfileInt(_T("Settings"), _T("COMPort"), 1), false);

	CString str;

	int nBaud = theApp.GetProfileInt(_T("Settings"), _T("BaudRate"), 38400);

	switch(nBaud)
	{
		case 1200:		m_cbBaud.SetCurSel(0);	break;
		case 2400:		m_cbBaud.SetCurSel(1);	break;
		case 9600:		m_cbBaud.SetCurSel(2);	break;
		case 19200:		m_cbBaud.SetCurSel(3);	break;
		case 38400:		m_cbBaud.SetCurSel(4);	break;
		case 57600:		m_cbBaud.SetCurSel(5);	break;
		case 115200:	m_cbBaud.SetCurSel(6);	break;

		default:		m_cbBaud.SetCurSel(2);	break;	// 9600
	}

	m_nInterval = theApp.GetProfileInt(_T("Settings"), _T("Interval"), 1000);

	m_strCommand = theApp.GetProfileString(_T("Settings"), _T("Command"));
	m_strFilename = theApp.GetProfileString(_T("Settings"), _T("Filename"));

	UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CArroyoDataLoggerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CArroyoDataLoggerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CArroyoDataLoggerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CArroyoDataLoggerDlg::OnBnClickedOk()
{
	if(!UpdateData(true))
		return;

	CString str;
	int nPort = (int)m_cbPort.GetItemData(m_cbPort.GetCurSel());
	m_cbBaud.GetWindowText(str);
	m_nBaudRate = _tstoi(str);
	m_dwStart = 0;
	m_nCount = 0;

	if(!m_serialport.Open(nPort, m_nBaudRate))
	{
		AfxMessageBox(_T("Cannot open communications port, aborting!"));
		return;
	}

	if(m_strFilename.GetLength())
	{
		m_file = fopen(CT2A(m_strFilename), "a+");

		if(m_file == NULL)
		{
			AfxMessageBox(_T("Cannot open output file, aborting!"));
			return;
		}
	}
	else
	{
		m_file = NULL;
		AfxMessageBox(_T("File name blank, will not log data."));
	}

	if(m_file)
	{
		fprintf(m_file, "Point,Time(ms),Response(s)\n");
		fclose(m_file);
		m_file = NULL;
	}

	theApp.WriteProfileInt(_T("Settings"), _T("COMPort"), nPort);
	theApp.WriteProfileInt(_T("Settings"), _T("BaudRate"), m_nBaudRate);
	theApp.WriteProfileInt(_T("Settings"), _T("Interval"), m_nInterval);
	theApp.WriteProfileString(_T("Settings"), _T("Command"), m_strCommand);
	theApp.WriteProfileString(_T("Settings"), _T("Filename"), m_strFilename);

	GetDlgItem(IDC_STATUS)->SetWindowText(_T(""));
	SetTimer(1, m_nInterval, NULL);
	m_bLogging = true;
	Enable(false);
}

void CArroyoDataLoggerDlg::Enable(bool bEnable)
{
	GetDlgItem(IDC_PORT)->EnableWindow(bEnable);
	GetDlgItem(IDC_BAUD)->EnableWindow(bEnable);
	GetDlgItem(IDC_INTERVAL)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMMAND)->EnableWindow(bEnable);
	GetDlgItem(IDC_FILENAME)->EnableWindow(bEnable);
	GetDlgItem(IDC_BROWSE)->EnableWindow(bEnable);
	GetDlgItem(IDOK)->EnableWindow(bEnable);
	GetDlgItem(IDC_STOP)->EnableWindow(!bEnable);
}

void CArroyoDataLoggerDlg::OnBnClickedStop()
{
	Enable(true);
	if(m_bLogging)
	{
		KillTimer(1);
		m_serialport.Close();
		if(m_file)
		{
			fclose(m_file);
			m_file = NULL;
		}

		m_bLogging = false;
	}
}

void CArroyoDataLoggerDlg::OnBnClickedCancel()
{
	OnBnClickedStop();
	OnCancel();
}

void CArroyoDataLoggerDlg::OnBnClickedBrowse()
{
	CFileDialog dlg(true, _T(".csv"), m_strFilename, 6, _T("CSV Files (*.csv)|*.csv|All Files (*.*)|*.*||"));

	if(dlg.DoModal())
	{
		m_strFilename = dlg.GetPathName();
		GetDlgItem(IDC_FILENAME)->SetWindowText(m_strFilename);
	}
}

void CArroyoDataLoggerDlg::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == 1)
	{
		if(m_dwStart == 0)
			m_dwStart = GetTickCount();

		DWORD dwTime = GetTickCount();

		m_serialport.SendData(CT2A(m_strCommand+_T("\n")), m_strCommand.GetLength()+1);
		CStringA str = m_serialport.ReadString(1000);

		m_nCount++;

		CStringA str2;
		
		str2.Format("%ldms: %s", dwTime - m_dwStart, str);

		GetDlgItem(IDC_STATUS)->SetWindowText(CA2T(str2));

		if(m_strFilename.GetLength())
		{
			m_file = fopen(CT2A(m_strFilename), "a+");

			if(m_file == NULL)
				GetDlgItem(IDC_STATUS)->SetWindowText(_T("Error writing to data file."));
			else
			{
				fprintf(m_file, "%d,%d,%s\n", m_nCount, dwTime - m_dwStart, str);
				fclose(m_file);
				m_file = NULL;
			}
		}
	}
	else if(nIDEvent == 2)
	{
		KillTimer(2);
		PopulateCOMPorts(m_cbPort, 0, true);
	}

	CDialog::OnTimer(nIDEvent);
}

void CArroyoDataLoggerDlg::PopulateCOMPorts(CComboBox& cbPort, int nPort, bool bLookForNewPort)
{
	CString strPort;
	COMMCONFIG CC;
	DWORD dwSize;
	CArray<int, int> nOldPorts;
	
	if(bLookForNewPort)
	{
		for(int j=0; j<cbPort.GetCount(); j++)
			nOldPorts.Add(cbPort.GetItemData(j));
	}

	cbPort.ResetContent();

	for(int i=1; i<127; i++)
	{
		strPort.Format(_T("COM%d"), i);
		dwSize = sizeof(CC);
		if(GetDefaultCommConfig(strPort, &CC, &dwSize))
		{
			int nSel = cbPort.AddString(strPort);
			cbPort.SetItemData(nSel, i);
			if(bLookForNewPort)
			{
				bool bFound = false;
				for(int j=0; j<nOldPorts.GetCount(); j++)
				{
					if(nOldPorts[j] == i)
					{
						bFound = true;
						break;
					}
				}

				if(!bFound)
					cbPort.SetCurSel(nSel);
			}
			else if(nPort == i)
				cbPort.SetCurSel(nSel);
		}
	}

	if(cbPort.GetCurSel() == CB_ERR)
		cbPort.SetCurSel(0);
}

afx_msg BOOL CArroyoDataLoggerDlg::OnDeviceChange(UINT nEventType, DWORD_PTR dwData)
{
	KillTimer(2);
	SetTimer(2, 500, NULL);

	return CDialog::OnDeviceChange(nEventType, dwData);
}

