// Serial.h

#pragma once

#define FC_DTRDSR       0x01
#define FC_RTSCTS       0x02
#define FC_XONXOFF      0x04
#define ASCII_BEL       0x07
#define ASCII_BS        0x08
#define ASCII_LF        0x0A
#define ASCII_CR        0x0D
#define ASCII_XON       0x11
#define ASCII_XOFF      0x13

class CSerial
{

public:
	CSerial();
	~CSerial();

	bool Open(LPCTSTR szPort, int nBaud = 9600);
	bool Open(int nPort, int nBaud = 9600);
	bool Close(void);

	int ReadData(void *buffer, int limit, int nTimeout = 2000);
	CStringA ReadString(int nTimeout=0);
	int SendData(const char *, int);
	int SendString(const char *szString) { return SendData(szString, (int)strlen(szString)); }
	int ReadDataWaiting(void);
	void Purge();

	int QueryString(const char *szString) { return SendData(szString, (int)strlen(szString)); }

	bool IsOpened(void){ return(m_bOpened); }

	int m_nPort;

protected:
	bool WriteCommByte(unsigned char);

	HANDLE m_hIDComDev;
	OVERLAPPED m_OverlappedRead, m_OverlappedWrite;
	bool m_bOpened;

};
